--Legal Notice: (C)2007 Altera Corporation. All rights reserved.  Your
--use of Altera Corporation's design tools, logic functions and other
--software and tools, and its AMPP partner logic functions, and any
--output files any of the foregoing (including device programming or
--simulation files), and any associated documentation or information are
--expressly subject to the terms and conditions of the Altera Program
--License Subscription Agreement or other applicable license agreement,
--including, without limitation, that your use is for the sole purpose
--of programming logic devices manufactured by Altera and sold by Altera
--or its authorized distributors.  Please refer to the applicable
--agreement for further details.


-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity sprite_buf is 
        port (
              -- inputs:
                 signal address : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal clk_50 : IN STD_LOGIC;
                 signal irq : IN STD_LOGIC;
                 signal reset : IN STD_LOGIC;
                 signal write : IN STD_LOGIC;
                 signal writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

              -- outputs:
                 signal address_out : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal clk_50_out : OUT STD_LOGIC;
                 signal irq_out : OUT STD_LOGIC;
                 signal reset_out : OUT STD_LOGIC;
                 signal write_out : OUT STD_LOGIC;
                 signal writedata_out : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
              );
end entity sprite_buf;


architecture europa of sprite_buf is
component buf is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal clk_50 : IN STD_LOGIC;
                    signal irq : IN STD_LOGIC;
                    signal reset : IN STD_LOGIC;
                    signal write : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

                 -- outputs:
                    signal address_out : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal clk_50_out : OUT STD_LOGIC;
                    signal irq_out : OUT STD_LOGIC;
                    signal reset_out : OUT STD_LOGIC;
                    signal write_out : OUT STD_LOGIC;
                    signal writedata_out : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component buf;

                signal internal_address_out :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal internal_clk_50_out :  STD_LOGIC;
                signal internal_irq_out :  STD_LOGIC;
                signal internal_reset_out :  STD_LOGIC;
                signal internal_write_out :  STD_LOGIC;
                signal internal_writedata_out :  STD_LOGIC_VECTOR (31 DOWNTO 0);

begin

  --the_buf, which is an e_instance
  the_buf : buf
    port map(
      address_out => internal_address_out,
      clk_50_out => internal_clk_50_out,
      irq_out => internal_irq_out,
      reset_out => internal_reset_out,
      write_out => internal_write_out,
      writedata_out => internal_writedata_out,
      address => address,
      clk_50 => clk_50,
      irq => irq,
      reset => reset,
      write => write,
      writedata => writedata
    );


  --vhdl renameroo for output signals
  address_out <= internal_address_out;
  --vhdl renameroo for output signals
  clk_50_out <= internal_clk_50_out;
  --vhdl renameroo for output signals
  irq_out <= internal_irq_out;
  --vhdl renameroo for output signals
  reset_out <= internal_reset_out;
  --vhdl renameroo for output signals
  write_out <= internal_write_out;
  --vhdl renameroo for output signals
  writedata_out <= internal_writedata_out;

end europa;

