--Legal Notice: (C)2007 Altera Corporation. All rights reserved.  Your
--use of Altera Corporation's design tools, logic functions and other
--software and tools, and its AMPP partner logic functions, and any
--output files any of the foregoing (including device programming or
--simulation files), and any associated documentation or information are
--expressly subject to the terms and conditions of the Altera Program
--License Subscription Agreement or other applicable license agreement,
--including, without limitation, that your use is for the sole purpose
--of programming logic devices manufactured by Altera and sold by Altera
--or its authorized distributors.  Please refer to the applicable
--agreement for further details.


-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity sprite_ctrl is 
        port (
              -- inputs:
                 signal address : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal clk_50 : IN STD_LOGIC;
                 signal reset : IN STD_LOGIC;
                 signal write : IN STD_LOGIC;
                 signal writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal x : IN STD_LOGIC_VECTOR (9 DOWNTO 0);
                 signal y : IN STD_LOGIC_VECTOR (9 DOWNTO 0);
                 signal y_blank : IN STD_LOGIC;

              -- outputs:
                 signal irq : OUT STD_LOGIC;
                 signal pixel : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal table : OUT STD_LOGIC_VECTOR (2 DOWNTO 0)
              );
end entity sprite_ctrl;


architecture europa of sprite_ctrl is
component sprite_controller is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal clk_50 : IN STD_LOGIC;
                    signal reset : IN STD_LOGIC;
                    signal write : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal x : IN STD_LOGIC_VECTOR (9 DOWNTO 0);
                    signal y : IN STD_LOGIC_VECTOR (9 DOWNTO 0);
                    signal y_blank : IN STD_LOGIC;

                 -- outputs:
                    signal irq : OUT STD_LOGIC;
                    signal pixel : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal table : OUT STD_LOGIC_VECTOR (2 DOWNTO 0)
                 );
end component sprite_controller;

                signal internal_irq :  STD_LOGIC;
                signal internal_pixel :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal internal_table :  STD_LOGIC_VECTOR (2 DOWNTO 0);

begin

  --the_sprite_controller, which is an e_instance
  the_sprite_controller : sprite_controller
    port map(
      irq => internal_irq,
      pixel => internal_pixel,
      table => internal_table,
      address => address,
      clk_50 => clk_50,
      reset => reset,
      write => write,
      writedata => writedata,
      x => x,
      y => y,
      y_blank => y_blank
    );


  --vhdl renameroo for output signals
  irq <= internal_irq;
  --vhdl renameroo for output signals
  pixel <= internal_pixel;
  --vhdl renameroo for output signals
  table <= internal_table;

end europa;

